cli.zsh 23 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839
  1. #!/usr/bin/env zsh
  2. function omz {
  3. [[ $# -gt 0 ]] || {
  4. _omz::help
  5. return 1
  6. }
  7. local command="$1"
  8. shift
  9. # Subcommand functions start with _ so that they don't
  10. # appear as completion entries when looking for `omz`
  11. (( ${+functions[_omz::$command]} )) || {
  12. _omz::help
  13. return 1
  14. }
  15. _omz::$command "$@"
  16. }
  17. function _omz {
  18. local -a cmds subcmds
  19. cmds=(
  20. 'changelog:Print the changelog'
  21. 'help:Usage information'
  22. 'plugin:Manage plugins'
  23. 'pr:Manage Oh My Zsh Pull Requests'
  24. 'reload:Reload the current zsh session'
  25. 'theme:Manage themes'
  26. 'update:Update Oh My Zsh'
  27. 'version:Show the version'
  28. )
  29. if (( CURRENT == 2 )); then
  30. _describe 'command' cmds
  31. elif (( CURRENT == 3 )); then
  32. case "$words[2]" in
  33. changelog) local -a refs
  34. refs=("${(@f)$(builtin cd -q "$ZSH"; command git for-each-ref --format="%(refname:short):%(subject)" refs/heads refs/tags)}")
  35. _describe 'command' refs ;;
  36. plugin) subcmds=(
  37. 'disable:Disable plugin(s)'
  38. 'enable:Enable plugin(s)'
  39. 'info:Get plugin information'
  40. 'list:List plugins'
  41. 'load:Load plugin(s)'
  42. )
  43. _describe 'command' subcmds ;;
  44. pr) subcmds=('clean:Delete all Pull Request branches' 'test:Test a Pull Request')
  45. _describe 'command' subcmds ;;
  46. theme) subcmds=('list:List themes' 'set:Set a theme in your .zshrc file' 'use:Load a theme')
  47. _describe 'command' subcmds ;;
  48. esac
  49. elif (( CURRENT == 4 )); then
  50. case "${words[2]}::${words[3]}" in
  51. plugin::(disable|enable|load))
  52. local -aU valid_plugins
  53. if [[ "${words[3]}" = disable ]]; then
  54. # if command is "disable", only offer already enabled plugins
  55. valid_plugins=($plugins)
  56. else
  57. valid_plugins=("$ZSH"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t) "$ZSH_CUSTOM"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t))
  58. # if command is "enable", remove already enabled plugins
  59. [[ "${words[3]}" = enable ]] && valid_plugins=(${valid_plugins:|plugins})
  60. fi
  61. _describe 'plugin' valid_plugins ;;
  62. plugin::info)
  63. local -aU plugins
  64. plugins=("$ZSH"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t) "$ZSH_CUSTOM"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t))
  65. _describe 'plugin' plugins ;;
  66. theme::(set|use))
  67. local -aU themes
  68. themes=("$ZSH"/themes/*.zsh-theme(-.N:t:r) "$ZSH_CUSTOM"/**/*.zsh-theme(-.N:r:gs:"$ZSH_CUSTOM"/themes/:::gs:"$ZSH_CUSTOM"/:::))
  69. _describe 'theme' themes ;;
  70. esac
  71. elif (( CURRENT > 4 )); then
  72. case "${words[2]}::${words[3]}" in
  73. plugin::(enable|disable|load))
  74. local -aU valid_plugins
  75. if [[ "${words[3]}" = disable ]]; then
  76. # if command is "disable", only offer already enabled plugins
  77. valid_plugins=($plugins)
  78. else
  79. valid_plugins=("$ZSH"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t) "$ZSH_CUSTOM"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t))
  80. # if command is "enable", remove already enabled plugins
  81. [[ "${words[3]}" = enable ]] && valid_plugins=(${valid_plugins:|plugins})
  82. fi
  83. # Remove plugins already passed as arguments
  84. # NOTE: $(( CURRENT - 1 )) is the last plugin argument completely passed, i.e. that which
  85. # has a space after them. This is to avoid removing plugins partially passed, which makes
  86. # the completion not add a space after the completed plugin.
  87. local -a args
  88. args=(${words[4,$(( CURRENT - 1))]})
  89. valid_plugins=(${valid_plugins:|args})
  90. _describe 'plugin' valid_plugins ;;
  91. esac
  92. fi
  93. return 0
  94. }
  95. # If run from a script, do not set the completion function
  96. if (( ${+functions[compdef]} )); then
  97. compdef _omz omz
  98. fi
  99. ## Utility functions
  100. function _omz::confirm {
  101. # If question supplied, ask it before reading the answer
  102. # NOTE: uses the logname of the caller function
  103. if [[ -n "$1" ]]; then
  104. _omz::log prompt "$1" "${${functrace[1]#_}%:*}"
  105. fi
  106. # Read one character
  107. read -r -k 1
  108. # If no newline entered, add a newline
  109. if [[ "$REPLY" != $'\n' ]]; then
  110. echo
  111. fi
  112. }
  113. function _omz::log {
  114. # if promptsubst is set, a message with `` or $()
  115. # will be run even if quoted due to `print -P`
  116. setopt localoptions nopromptsubst
  117. # $1 = info|warn|error|debug
  118. # $2 = text
  119. # $3 = (optional) name of the logger
  120. local logtype=$1
  121. local logname=${3:-${${functrace[1]#_}%:*}}
  122. # Don't print anything if debug is not active
  123. if [[ $logtype = debug && -z $_OMZ_DEBUG ]]; then
  124. return
  125. fi
  126. # Choose coloring based on log type
  127. case "$logtype" in
  128. prompt) print -Pn "%S%F{blue}$logname%f%s: $2" ;;
  129. debug) print -P "%F{white}$logname%f: $2" ;;
  130. info) print -P "%F{green}$logname%f: $2" ;;
  131. warn) print -P "%S%F{yellow}$logname%f%s: $2" ;;
  132. error) print -P "%S%F{red}$logname%f%s: $2" ;;
  133. esac >&2
  134. }
  135. ## User-facing commands
  136. function _omz::help {
  137. cat >&2 <<EOF
  138. Usage: omz <command> [options]
  139. Available commands:
  140. help Print this help message
  141. changelog Print the changelog
  142. plugin <command> Manage plugins
  143. pr <command> Manage Oh My Zsh Pull Requests
  144. reload Reload the current zsh session
  145. theme <command> Manage themes
  146. update Update Oh My Zsh
  147. version Show the version
  148. EOF
  149. }
  150. function _omz::changelog {
  151. local version=${1:-HEAD} format=${3:-"--text"}
  152. if (
  153. builtin cd -q "$ZSH"
  154. ! command git show-ref --verify refs/heads/$version && \
  155. ! command git show-ref --verify refs/tags/$version && \
  156. ! command git rev-parse --verify "${version}^{commit}"
  157. ) &>/dev/null; then
  158. cat >&2 <<EOF
  159. Usage: ${(j: :)${(s.::.)0#_}} [version]
  160. NOTE: <version> must be a valid branch, tag or commit.
  161. EOF
  162. return 1
  163. fi
  164. "$ZSH/tools/changelog.sh" "$version" "${2:-}" "$format"
  165. }
  166. function _omz::plugin {
  167. (( $# > 0 && $+functions[$0::$1] )) || {
  168. cat >&2 <<EOF
  169. Usage: ${(j: :)${(s.::.)0#_}} <command> [options]
  170. Available commands:
  171. disable <plugin> Disable plugin(s)
  172. enable <plugin> Enable plugin(s)
  173. info <plugin> Get information of a plugin
  174. list List all available Oh My Zsh plugins
  175. load <plugin> Load plugin(s)
  176. EOF
  177. return 1
  178. }
  179. local command="$1"
  180. shift
  181. $0::$command "$@"
  182. }
  183. function _omz::plugin::disable {
  184. if [[ -z "$1" ]]; then
  185. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <plugin> [...]"
  186. return 1
  187. fi
  188. # Check that plugin is in $plugins
  189. local -a dis_plugins
  190. for plugin in "$@"; do
  191. if [[ ${plugins[(Ie)$plugin]} -eq 0 ]]; then
  192. _omz::log warn "plugin '$plugin' is not enabled."
  193. continue
  194. fi
  195. dis_plugins+=("$plugin")
  196. done
  197. # Exit if there are no enabled plugins to disable
  198. if [[ ${#dis_plugins} -eq 0 ]]; then
  199. return 1
  200. fi
  201. # Remove plugins substitution awk script
  202. local awk_subst_plugins="\
  203. gsub(/[ \t]+(${(j:|:)dis_plugins})[ \t]+/, \" \") # with spaces before or after
  204. gsub(/[ \t]+(${(j:|:)dis_plugins})$/, \"\") # with spaces before and EOL
  205. gsub(/^(${(j:|:)dis_plugins})[ \t]+/, \"\") # with BOL and spaces after
  206. gsub(/\((${(j:|:)dis_plugins})[ \t]+/, \"(\") # with parenthesis before and spaces after
  207. gsub(/[ \t]+(${(j:|:)dis_plugins})\)/, \")\") # with spaces before or parenthesis after
  208. gsub(/\((${(j:|:)dis_plugins})\)/, \"()\") # with only parentheses
  209. gsub(/^(${(j:|:)dis_plugins})\)/, \")\") # with BOL and closing parenthesis
  210. gsub(/\((${(j:|:)dis_plugins})$/, \"(\") # with opening parenthesis and EOL
  211. "
  212. # Disable plugins awk script
  213. local awk_script="
  214. # if plugins=() is in oneline form, substitute disabled plugins and go to next line
  215. /^[ \t]*plugins=\([^#]+\).*\$/ {
  216. $awk_subst_plugins
  217. print \$0
  218. next
  219. }
  220. # if plugins=() is in multiline form, enable multi flag and disable plugins if they're there
  221. /^[ \t]*plugins=\(/ {
  222. multi=1
  223. $awk_subst_plugins
  224. print \$0
  225. next
  226. }
  227. # if multi flag is enabled and we find a valid closing parenthesis, remove plugins and disable multi flag
  228. multi == 1 && /^[^#]*\)/ {
  229. multi=0
  230. $awk_subst_plugins
  231. print \$0
  232. next
  233. }
  234. multi == 1 && length(\$0) > 0 {
  235. $awk_subst_plugins
  236. if (length(\$0) > 0) print \$0
  237. next
  238. }
  239. { print \$0 }
  240. "
  241. local zdot="${ZDOTDIR:-$HOME}"
  242. local zshrc="${${:-"${zdot}/.zshrc"}:A}"
  243. awk "$awk_script" "$zshrc" > "$zdot/.zshrc.new" \
  244. && command cp -f "$zshrc" "$zdot/.zshrc.bck" \
  245. && command mv -f "$zdot/.zshrc.new" "$zshrc"
  246. # Exit if the new .zshrc file wasn't created correctly
  247. [[ $? -eq 0 ]] || {
  248. local ret=$?
  249. _omz::log error "error disabling plugins."
  250. return $ret
  251. }
  252. # Exit if the new .zshrc file has syntax errors
  253. if ! command zsh -n "$zdot/.zshrc"; then
  254. _omz::log error "broken syntax in '"${zdot/#$HOME/\~}/.zshrc"'. Rolling back changes..."
  255. command mv -f "$zdot/.zshrc.bck" "$zshrc"
  256. return 1
  257. fi
  258. # Restart the zsh session if there were no errors
  259. _omz::log info "plugins disabled: ${(j:, :)dis_plugins}."
  260. # Only reload zsh if run in an interactive session
  261. [[ ! -o interactive ]] || _omz::reload
  262. }
  263. function _omz::plugin::enable {
  264. if [[ -z "$1" ]]; then
  265. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <plugin> [...]"
  266. return 1
  267. fi
  268. # Check that plugin is not in $plugins
  269. local -a add_plugins
  270. for plugin in "$@"; do
  271. if [[ ${plugins[(Ie)$plugin]} -ne 0 ]]; then
  272. _omz::log warn "plugin '$plugin' is already enabled."
  273. continue
  274. fi
  275. add_plugins+=("$plugin")
  276. done
  277. # Exit if there are no plugins to enable
  278. if [[ ${#add_plugins} -eq 0 ]]; then
  279. return 1
  280. fi
  281. # Enable plugins awk script
  282. local awk_script="
  283. # if plugins=() is in oneline form, substitute ) with new plugins and go to the next line
  284. /^[ \t]*plugins=\([^#]+\).*\$/ {
  285. sub(/\)/, \" $add_plugins&\")
  286. print \$0
  287. next
  288. }
  289. # if plugins=() is in multiline form, enable multi flag
  290. /^[ \t]*plugins=\(/ {
  291. multi=1
  292. }
  293. # if multi flag is enabled and we find a valid closing parenthesis,
  294. # add new plugins and disable multi flag
  295. multi == 1 && /^[^#]*\)/ {
  296. multi=0
  297. sub(/\)/, \" $add_plugins&\")
  298. print \$0
  299. next
  300. }
  301. { print \$0 }
  302. "
  303. local zdot="${ZDOTDIR:-$HOME}"
  304. local zshrc="${${:-"${zdot}/.zshrc"}:A}"
  305. awk "$awk_script" "$zshrc" > "$zdot/.zshrc.new" \
  306. && command cp -f "$zshrc" "$zdot/.zshrc.bck" \
  307. && command mv -f "$zdot/.zshrc.new" "$zshrc"
  308. # Exit if the new .zshrc file wasn't created correctly
  309. [[ $? -eq 0 ]] || {
  310. local ret=$?
  311. _omz::log error "error enabling plugins."
  312. return $ret
  313. }
  314. # Exit if the new .zshrc file has syntax errors
  315. if ! command zsh -n "$zdot/.zshrc"; then
  316. _omz::log error "broken syntax in '"${zdot/#$HOME/\~}/.zshrc"'. Rolling back changes..."
  317. command mv -f "$zdot/.zshrc.bck" "$zshrc"
  318. return 1
  319. fi
  320. # Restart the zsh session if there were no errors
  321. _omz::log info "plugins enabled: ${(j:, :)add_plugins}."
  322. # Only reload zsh if run in an interactive session
  323. [[ ! -o interactive ]] || _omz::reload
  324. }
  325. function _omz::plugin::info {
  326. if [[ -z "$1" ]]; then
  327. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <plugin>"
  328. return 1
  329. fi
  330. local readme
  331. for readme in "$ZSH_CUSTOM/plugins/$1/README.md" "$ZSH/plugins/$1/README.md"; do
  332. if [[ -f "$readme" ]]; then
  333. (( ${+commands[less]} )) && less "$readme" || cat "$readme"
  334. return 0
  335. fi
  336. done
  337. if [[ -d "$ZSH_CUSTOM/plugins/$1" || -d "$ZSH/plugins/$1" ]]; then
  338. _omz::log error "the '$1' plugin doesn't have a README file"
  339. else
  340. _omz::log error "'$1' plugin not found"
  341. fi
  342. return 1
  343. }
  344. function _omz::plugin::list {
  345. local -a custom_plugins builtin_plugins
  346. custom_plugins=("$ZSH_CUSTOM"/plugins/*(-/N:t))
  347. builtin_plugins=("$ZSH"/plugins/*(-/N:t))
  348. # If the command is being piped, print all found line by line
  349. if [[ ! -t 1 ]]; then
  350. print -l ${(q-)custom_plugins} ${(q-)builtin_plugins}
  351. return
  352. fi
  353. if (( ${#custom_plugins} )); then
  354. print -P "%U%BCustom plugins%b%u:"
  355. print -lac ${(q-)custom_plugins}
  356. fi
  357. if (( ${#builtin_plugins} )); then
  358. (( ${#custom_plugins} )) && echo # add a line of separation
  359. print -P "%U%BBuilt-in plugins%b%u:"
  360. print -lac ${(q-)builtin_plugins}
  361. fi
  362. }
  363. function _omz::plugin::load {
  364. if [[ -z "$1" ]]; then
  365. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <plugin> [...]"
  366. return 1
  367. fi
  368. local plugin base has_completion=0
  369. for plugin in "$@"; do
  370. if [[ -d "$ZSH_CUSTOM/plugins/$plugin" ]]; then
  371. base="$ZSH_CUSTOM/plugins/$plugin"
  372. elif [[ -d "$ZSH/plugins/$plugin" ]]; then
  373. base="$ZSH/plugins/$plugin"
  374. else
  375. _omz::log warn "plugin '$plugin' not found"
  376. continue
  377. fi
  378. # Check if its a valid plugin
  379. if [[ ! -f "$base/_$plugin" && ! -f "$base/$plugin.plugin.zsh" ]]; then
  380. _omz::log warn "'$plugin' is not a valid plugin"
  381. continue
  382. # It is a valid plugin, add its directory to $fpath unless it is already there
  383. elif (( ! ${fpath[(Ie)$base]} )); then
  384. fpath=("$base" $fpath)
  385. fi
  386. # Check if it has completion to reload compinit
  387. local -a comp_files
  388. comp_files=($base/_*(N))
  389. has_completion=$(( $#comp_files > 0 ))
  390. # Load the plugin
  391. if [[ -f "$base/$plugin.plugin.zsh" ]]; then
  392. source "$base/$plugin.plugin.zsh"
  393. fi
  394. done
  395. # If we have completion, we need to reload the completion
  396. # We pass -D to avoid generating a new dump file, which would overwrite our
  397. # current one for the next session (and we don't want that because we're not
  398. # actually enabling the plugins for the next session).
  399. # Note that we still have to pass -d "$_comp_dumpfile", so that compinit
  400. # doesn't use the default zcompdump location (${ZDOTDIR:-$HOME}/.zcompdump).
  401. if (( has_completion )); then
  402. compinit -D -d "$_comp_dumpfile"
  403. fi
  404. }
  405. function _omz::pr {
  406. (( $# > 0 && $+functions[$0::$1] )) || {
  407. cat >&2 <<EOF
  408. Usage: ${(j: :)${(s.::.)0#_}} <command> [options]
  409. Available commands:
  410. clean Delete all PR branches (ohmyzsh/pull-*)
  411. test <PR_number_or_URL> Fetch PR #NUMBER and rebase against master
  412. EOF
  413. return 1
  414. }
  415. local command="$1"
  416. shift
  417. $0::$command "$@"
  418. }
  419. function _omz::pr::clean {
  420. (
  421. set -e
  422. builtin cd -q "$ZSH"
  423. # Check if there are PR branches
  424. local fmt branches
  425. fmt="%(color:bold blue)%(align:18,right)%(refname:short)%(end)%(color:reset) %(color:dim bold red)%(objectname:short)%(color:reset) %(color:yellow)%(contents:subject)"
  426. branches="$(command git for-each-ref --sort=-committerdate --color --format="$fmt" "refs/heads/ohmyzsh/pull-*")"
  427. # Exit if there are no PR branches
  428. if [[ -z "$branches" ]]; then
  429. _omz::log info "there are no Pull Request branches to remove."
  430. return
  431. fi
  432. # Print found PR branches
  433. echo "$branches\n"
  434. # Confirm before removing the branches
  435. _omz::confirm "do you want remove these Pull Request branches? [Y/n] "
  436. # Only proceed if the answer is a valid yes option
  437. [[ "$REPLY" != [yY$'\n'] ]] && return
  438. _omz::log info "removing all Oh My Zsh Pull Request branches..."
  439. command git branch --list 'ohmyzsh/pull-*' | while read branch; do
  440. command git branch -D "$branch"
  441. done
  442. )
  443. }
  444. function _omz::pr::test {
  445. # Allow $1 to be a URL to the pull request
  446. if [[ "$1" = https://* ]]; then
  447. 1="${1:t}"
  448. fi
  449. # Check the input
  450. if ! [[ -n "$1" && "$1" =~ ^[[:digit:]]+$ ]]; then
  451. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <PR_NUMBER_or_URL>"
  452. return 1
  453. fi
  454. # Save current git HEAD
  455. local branch
  456. branch=$(builtin cd -q "$ZSH"; git symbolic-ref --short HEAD) || {
  457. _omz::log error "error when getting the current git branch. Aborting..."
  458. return 1
  459. }
  460. # Fetch PR onto ohmyzsh/pull-<PR_NUMBER> branch and rebase against master
  461. # If any of these operations fail, undo the changes made
  462. (
  463. set -e
  464. builtin cd -q "$ZSH"
  465. # Get the ohmyzsh git remote
  466. command git remote -v | while read remote url _; do
  467. case "$url" in
  468. https://github.com/ohmyzsh/ohmyzsh(|.git)) found=1; break ;;
  469. git@github.com:ohmyzsh/ohmyzsh(|.git)) found=1; break ;;
  470. esac
  471. done
  472. (( $found )) || {
  473. _omz::log error "could not found the ohmyzsh git remote. Aborting..."
  474. return 1
  475. }
  476. # Fetch pull request head
  477. _omz::log info "fetching PR #$1 to ohmyzsh/pull-$1..."
  478. command git fetch -f "$remote" refs/pull/$1/head:ohmyzsh/pull-$1 || {
  479. _omz::log error "error when trying to fetch PR #$1."
  480. return 1
  481. }
  482. # Rebase pull request branch against the current master
  483. _omz::log info "rebasing PR #$1..."
  484. local ret gpgsign
  485. {
  486. # Back up commit.gpgsign setting: use --local to get the current repository
  487. # setting, not the global one. If --local is not a known option, it will
  488. # exit with a 129 status code.
  489. gpgsign=$(command git config --local commit.gpgsign 2>/dev/null) || ret=$?
  490. [[ $ret -ne 129 ]] || gpgsign=$(command git config commit.gpgsign 2>/dev/null)
  491. command git config commit.gpgsign false
  492. command git rebase master ohmyzsh/pull-$1 || {
  493. command git rebase --abort &>/dev/null
  494. _omz::log warn "could not rebase PR #$1 on top of master."
  495. _omz::log warn "you might not see the latest stable changes."
  496. _omz::log info "run \`zsh\` to test the changes."
  497. return 1
  498. }
  499. } always {
  500. case "$gpgsign" in
  501. "") command git config --unset commit.gpgsign ;;
  502. *) command git config commit.gpgsign "$gpgsign" ;;
  503. esac
  504. }
  505. _omz::log info "fetch of PR #${1} successful."
  506. )
  507. # If there was an error, abort running zsh to test the PR
  508. [[ $? -eq 0 ]] || return 1
  509. # Run zsh to test the changes
  510. _omz::log info "running \`zsh\` to test the changes. Run \`exit\` to go back."
  511. command zsh -l
  512. # After testing, go back to the previous HEAD if the user wants
  513. _omz::confirm "do you want to go back to the previous branch? [Y/n] "
  514. # Only proceed if the answer is a valid yes option
  515. [[ "$REPLY" != [yY$'\n'] ]] && return
  516. (
  517. set -e
  518. builtin cd -q "$ZSH"
  519. command git checkout "$branch" -- || {
  520. _omz::log error "could not go back to the previous branch ('$branch')."
  521. return 1
  522. }
  523. )
  524. }
  525. function _omz::reload {
  526. # Delete current completion cache
  527. command rm -f $_comp_dumpfile $ZSH_COMPDUMP
  528. # Old zsh versions don't have ZSH_ARGZERO
  529. local zsh="${ZSH_ARGZERO:-${functrace[-1]%:*}}"
  530. # Check whether to run a login shell
  531. [[ "$zsh" = -* || -o login ]] && exec -l "${zsh#-}" || exec "$zsh"
  532. }
  533. function _omz::theme {
  534. (( $# > 0 && $+functions[$0::$1] )) || {
  535. cat >&2 <<EOF
  536. Usage: ${(j: :)${(s.::.)0#_}} <command> [options]
  537. Available commands:
  538. list List all available Oh My Zsh themes
  539. set <theme> Set a theme in your .zshrc file
  540. use <theme> Load a theme
  541. EOF
  542. return 1
  543. }
  544. local command="$1"
  545. shift
  546. $0::$command "$@"
  547. }
  548. function _omz::theme::list {
  549. local -a custom_themes builtin_themes
  550. custom_themes=("$ZSH_CUSTOM"/**/*.zsh-theme(-.N:r:gs:"$ZSH_CUSTOM"/themes/:::gs:"$ZSH_CUSTOM"/:::))
  551. builtin_themes=("$ZSH"/themes/*.zsh-theme(-.N:t:r))
  552. # If the command is being piped, print all found line by line
  553. if [[ ! -t 1 ]]; then
  554. print -l ${(q-)custom_themes} ${(q-)builtin_themes}
  555. return
  556. fi
  557. # Print theme in use
  558. if [[ -n "$ZSH_THEME" ]]; then
  559. print -Pn "%U%BCurrent theme%b%u: "
  560. [[ $ZSH_THEME = random ]] && echo "$RANDOM_THEME (via random)" || echo "$ZSH_THEME"
  561. echo
  562. fi
  563. # Print custom themes if there are any
  564. if (( ${#custom_themes} )); then
  565. print -P "%U%BCustom themes%b%u:"
  566. print -lac ${(q-)custom_themes}
  567. echo
  568. fi
  569. # Print built-in themes
  570. print -P "%U%BBuilt-in themes%b%u:"
  571. print -lac ${(q-)builtin_themes}
  572. }
  573. function _omz::theme::set {
  574. if [[ -z "$1" ]]; then
  575. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <theme>"
  576. return 1
  577. fi
  578. # Check that theme exists
  579. if [[ ! -f "$ZSH_CUSTOM/$1.zsh-theme" ]] \
  580. && [[ ! -f "$ZSH_CUSTOM/themes/$1.zsh-theme" ]] \
  581. && [[ ! -f "$ZSH/themes/$1.zsh-theme" ]]; then
  582. _omz::log error "%B$1%b theme not found"
  583. return 1
  584. fi
  585. # Enable theme in .zshrc
  586. local awk_script='
  587. !set && /^[ \t]*ZSH_THEME=[^#]+.*$/ {
  588. set=1
  589. sub(/^[ \t]*ZSH_THEME=[^#]+.*$/, "ZSH_THEME=\"'$1'\" # set by `omz`")
  590. print $0
  591. next
  592. }
  593. { print $0 }
  594. END {
  595. # If no ZSH_THEME= line was found, return an error
  596. if (!set) exit 1
  597. }
  598. '
  599. local zdot="${ZDOTDIR:-$HOME}"
  600. local zshrc="${${:-"${zdot}/.zshrc"}:A}"
  601. awk "$awk_script" "$zshrc" > "$zdot/.zshrc.new" \
  602. || {
  603. # Prepend ZSH_THEME= line to .zshrc if it doesn't exist
  604. cat <<EOF
  605. ZSH_THEME="$1" # set by \`omz\`
  606. EOF
  607. cat "$zdot/.zshrc"
  608. } > "$zdot/.zshrc.new" \
  609. && command cp -f "$zshrc" "$zdot/.zshrc.bck" \
  610. && command mv -f "$zdot/.zshrc.new" "$zshrc"
  611. # Exit if the new .zshrc file wasn't created correctly
  612. [[ $? -eq 0 ]] || {
  613. local ret=$?
  614. _omz::log error "error setting theme."
  615. return $ret
  616. }
  617. # Exit if the new .zshrc file has syntax errors
  618. if ! command zsh -n "$zdot/.zshrc"; then
  619. _omz::log error "broken syntax in '"${zdot/#$HOME/\~}/.zshrc"'. Rolling back changes..."
  620. command mv -f "$zdot/.zshrc.bck" "$zshrc"
  621. return 1
  622. fi
  623. # Restart the zsh session if there were no errors
  624. _omz::log info "'$1' theme set correctly."
  625. # Only reload zsh if run in an interactive session
  626. [[ ! -o interactive ]] || _omz::reload
  627. }
  628. function _omz::theme::use {
  629. if [[ -z "$1" ]]; then
  630. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <theme>"
  631. return 1
  632. fi
  633. # Respect compatibility with old lookup order
  634. if [[ -f "$ZSH_CUSTOM/$1.zsh-theme" ]]; then
  635. source "$ZSH_CUSTOM/$1.zsh-theme"
  636. elif [[ -f "$ZSH_CUSTOM/themes/$1.zsh-theme" ]]; then
  637. source "$ZSH_CUSTOM/themes/$1.zsh-theme"
  638. elif [[ -f "$ZSH/themes/$1.zsh-theme" ]]; then
  639. source "$ZSH/themes/$1.zsh-theme"
  640. else
  641. _omz::log error "%B$1%b theme not found"
  642. return 1
  643. fi
  644. # Update theme settings
  645. ZSH_THEME="$1"
  646. [[ $1 = random ]] || unset RANDOM_THEME
  647. }
  648. function _omz::update {
  649. # Check if git command is available
  650. (( $+commands[git] )) || {
  651. _omz::log error "git is not installed. Aborting..."
  652. return 1
  653. }
  654. local last_commit=$(builtin cd -q "$ZSH"; git rev-parse HEAD 2>/dev/null)
  655. [[ $? -eq 0 ]] || {
  656. _omz::log error "\`$ZSH\` is not a git directory. Aborting..."
  657. return 1
  658. }
  659. # Run update script
  660. zstyle -s ':omz:update' verbose verbose_mode || verbose_mode=default
  661. if [[ "$1" != --unattended ]]; then
  662. ZSH="$ZSH" command zsh -f "$ZSH/tools/upgrade.sh" -i -v $verbose_mode || return $?
  663. else
  664. ZSH="$ZSH" command zsh -f "$ZSH/tools/upgrade.sh" -v $verbose_mode || return $?
  665. fi
  666. # Update last updated file
  667. zmodload zsh/datetime
  668. echo "LAST_EPOCH=$(( EPOCHSECONDS / 60 / 60 / 24 ))" >! "${ZSH_CACHE_DIR}/.zsh-update"
  669. # Remove update lock if it exists
  670. command rm -rf "$ZSH/log/update.lock"
  671. # Restart the zsh session if there were changes
  672. if [[ "$1" != --unattended && "$(builtin cd -q "$ZSH"; git rev-parse HEAD)" != "$last_commit" ]]; then
  673. # Old zsh versions don't have ZSH_ARGZERO
  674. local zsh="${ZSH_ARGZERO:-${functrace[-1]%:*}}"
  675. # Check whether to run a login shell
  676. [[ "$zsh" = -* || -o login ]] && exec -l "${zsh#-}" || exec "$zsh"
  677. fi
  678. }
  679. function _omz::version {
  680. (
  681. builtin cd -q "$ZSH"
  682. # Get the version name:
  683. # 1) try tag-like version
  684. # 2) try branch name
  685. # 3) try name-rev (tag~<rev> or branch~<rev>)
  686. local version
  687. version=$(command git describe --tags HEAD 2>/dev/null) \
  688. || version=$(command git symbolic-ref --quiet --short HEAD 2>/dev/null) \
  689. || version=$(command git name-rev --no-undefined --name-only --exclude="remotes/*" HEAD 2>/dev/null) \
  690. || version="<detached>"
  691. # Get short hash for the current HEAD
  692. local commit=$(command git rev-parse --short HEAD 2>/dev/null)
  693. # Show version and commit hash
  694. printf "%s (%s)\n" "$version" "$commit"
  695. )
  696. }